cern.colt.map

## Class AbstractDoubleIntMap

- java.lang.Object
- - cern.colt.PersistentObject
  - - cern.colt.map.AbstractMap
    - - cern.colt.map.AbstractDoubleIntMap

All Implemented Interfaces:
  java.io.Serializable, java.lang.Cloneable

Direct Known Subclasses:
  OpenDoubleIntHashMap

    public abstract class AbstractDoubleIntMap
    extends AbstractMap

Abstract base class for hash maps holding (key,value) associations of type `(double-->int)`. First see the package summary and javadoc tree view to get the broad picture.

Implementation:

Almost all methods are expressed in terms of `forEachKey(DoubleProcedure)`. As such they are fully functional, but inefficient. Override them in subclasses if necessary.

Version:
  1.0, 09/24/99
See Also:
  `HashMap`, Serialized Form

### Field Summary

### Fields inherited from class cern.colt.PersistentObject

`serialVersionUID`

### Method Summary

Methods
`boolean` `containsKey(double key)` Returns `true` if the receiver contains the specified key.
`boolean` `containsValue(int value)` Returns `true` if the receiver contains the specified value.
`AbstractDoubleIntMap` `copy()` Returns a deep copy of the receiver; uses `clone()` and casts the result.
`boolean` `equals(java.lang.Object obj)` Compares the specified object with this map for equality.
`abstract boolean` `forEachKey(DoubleProcedure procedure)` Applies a procedure to each key of the receiver, if any.
`boolean` `forEachPair(DoubleIntProcedure procedure)` Applies a procedure to each (key,value) pair of the receiver, if any.
`abstract int` `get(double key)` Returns the value associated with the specified key.
`double` `keyOf(int value)` Returns the first key the given value is associated with.
`DoubleArrayList` `keys()` Returns a list filled with all keys contained in the receiver.
`void` `keys(DoubleArrayList list)` Fills all keys contained in the receiver into the specified list.
`void` `keysSortedByValue(DoubleArrayList keyList)` Fills all keys sorted ascending by their associated value into the specified list.
`void` `pairsMatching(DoubleIntProcedure condition, DoubleArrayList keyList, IntArrayList valueList)` Fills all pairs satisfying a given condition into the specified lists.
`void` `pairsSortedByKey(DoubleArrayList keyList, IntArrayList valueList)` Fills all keys and values sorted ascending by key into the specified lists.
`void` `pairsSortedByValue(DoubleArrayList keyList, IntArrayList valueList)` Fills all keys and values sorted ascending by value into the specified lists.
`abstract boolean` `put(double key, int value)` Associates the given key with the given value.
`abstract boolean` `removeKey(double key)` Removes the given key with its associated element from the receiver, if present.
`java.lang.String` `toString()` Returns a string representation of the receiver, containing the String representation of each key-value pair, sorted ascending by key.
`java.lang.String` `toStringByValue()` Returns a string representation of the receiver, containing the String representation of each key-value pair, sorted ascending by value.
`IntArrayList` `values()` Returns a list filled with all values contained in the receiver.
`void` `values(IntArrayList list)` Fills all values contained in the receiver into the specified list.

### Methods inherited from class cern.colt.map.AbstractMap

`clear, ensureCapacity, isEmpty, size, trimToSize`

### Methods inherited from class cern.colt.PersistentObject

`clone`

### Methods inherited from class java.lang.Object

`getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Method Detail

#### containsKey

    public boolean containsKey(double key)

Returns `true` if the receiver contains the specified key.

Returns:
  `true` if the receiver contains the specified key.

#### containsValue

    public boolean containsValue(int value)

Returns `true` if the receiver contains the specified value.

Returns:
  `true` if the receiver contains the specified value.

#### copy

    public AbstractDoubleIntMap copy()

Returns a deep copy of the receiver; uses `clone()` and casts the result.

Returns:
  a deep copy of the receiver.

#### equals

    public boolean equals(java.lang.Object obj)

Compares the specified object with this map for equality. Returns `true` if the given object is also a map and the two maps represent the same mappings. More formally, two maps `m1` and `m2` represent the same mappings iff

     m1.forEachPair(
                    new DoubleIntProcedure() {
                            public boolean apply(double key, int value) {
                                    return m2.containsKey(key) && m2.get(key) == value;
                            }
                    }
            )
     &&
     m2.forEachPair(
                    new DoubleIntProcedure() {
                            public boolean apply(double key, int value) {
                                    return m1.containsKey(key) && m1.get(key) == value;
                            }
                    }
            );

This implementation first checks if the specified object is this map; if so it returns `true`. Then, it checks if the specified object is a map whose size is identical to the size of this set; if not, it it returns `false`. If so, it applies the iteration as described above.

Overrides:
  `equals` in class `java.lang.Object`
Parameters:
  `obj` - object to be compared for equality with this map.
Returns:
  `true` if the specified object is equal to this map.

#### forEachKey

    public abstract boolean forEachKey(DoubleProcedure procedure)

Applies a procedure to each key of the receiver, if any. Note: Iterates over the keys in no particular order. Subclasses can define a particular order, for example, "sorted by key". All methods which can be expressed in terms of this method (most methods can) must guarantee to use the same order defined by this method, even if it is no particular order. This is necessary so that, for example, methods `keys` and `values` will yield association pairs, not two uncorrelated lists.

Parameters:
  `procedure` - the procedure to be applied. Stops iteration if the procedure returns `false`, otherwise continues.
Returns:
  `false` if the procedure stopped before all keys where iterated over, `true` otherwise.

#### forEachPair

    public boolean forEachPair(DoubleIntProcedure procedure)

Applies a procedure to each (key,value) pair of the receiver, if any. Iteration order is guaranteed to be identical to the order used by method `forEachKey(DoubleProcedure)`.

Parameters:
  `procedure` - the procedure to be applied. Stops iteration if the procedure returns `false`, otherwise continues.
Returns:
  `false` if the procedure stopped before all keys where iterated over, `true` otherwise.

#### get

    public abstract int get(double key)

Returns the value associated with the specified key. It is often a good idea to first check with `containsKey(double)` whether the given key has a value associated or not, i.e. whether there exists an association for the given key or not.

Parameters:
  `key` - the key to be searched for.
Returns:
  the value associated with the specified key; `0` if no such key is present.

#### keyOf

    public double keyOf(int value)

Returns the first key the given value is associated with. It is often a good idea to first check with `containsValue(int)` whether there exists an association from a key to this value. Search order is guaranteed to be identical to the order used by method `forEachKey(DoubleProcedure)`.

Parameters:
  `value` - the value to search for.
Returns:
  the first key for which holds `get(key) == value`; returns `Double.NaN` if no such key exists.

#### keys

    public DoubleArrayList keys()

Returns a list filled with all keys contained in the receiver. The returned list has a size that equals `this.size()`. Note: Keys are filled into the list in no particular order. However, the order is identical to the order used by method `forEachKey(DoubleProcedure)`.

This method can be used to iterate over the keys of the receiver.

Returns:
  the keys.

#### keys

    public void keys(DoubleArrayList list)

Fills all keys contained in the receiver into the specified list. Fills the list, starting at index 0. After this call returns the specified list has a new size that equals `this.size()`. Iteration order is guaranteed to be identical to the order used by method `forEachKey(DoubleProcedure)`.

This method can be used to iterate over the keys of the receiver.

Parameters:
  `list` - the list to be filled, can have any size.

#### keysSortedByValue

    public void keysSortedByValue(DoubleArrayList keyList)

Fills all keys sorted ascending by their associated value into the specified list. Fills into the list, starting at index 0. After this call returns the specified list has a new size that equals `this.size()`. Primary sort criterium is "value", secondary sort criterium is "key". This means that if any two values are equal, the smaller key comes first.

Example:
`keys = (8,7,6), values = (1,2,2) --> keyList = (8,6,7)`

Parameters:
  `keyList` - the list to be filled, can have any size.

#### pairsMatching

    public void pairsMatching(DoubleIntProcedure condition,
                     DoubleArrayList keyList,
                     IntArrayList valueList)

Fills all pairs satisfying a given condition into the specified lists. Fills into the lists, starting at index 0. After this call returns the specified lists both have a new size, the number of pairs satisfying the condition. Iteration order is guaranteed to be identical to the order used by method `forEachKey(DoubleProcedure)`.

Example:

    DoubleIntProcedure condition = new DoubleIntProcedure() { // match even values only
            public boolean apply(double key, int value) { return value%2==0; }
    }
    keys = (8,7,6), values = (1,2,2) --> keyList = (6,8), valueList = (2,1)

Parameters:
  `condition` - the condition to be matched. Takes the current key as first and the current value as second argument.
  `keyList` - the list to be filled with keys, can have any size.
  `valueList` - the list to be filled with values, can have any size.

#### pairsSortedByKey

    public void pairsSortedByKey(DoubleArrayList keyList,
                        IntArrayList valueList)

Fills all keys and values sorted ascending by key into the specified lists. Fills into the lists, starting at index 0. After this call returns the specified lists both have a new size that equals `this.size()`.

Example:
`keys = (8,7,6), values = (1,2,2) --> keyList = (6,7,8), valueList = (2,2,1)`

Parameters:
  `keyList` - the list to be filled with keys, can have any size.
  `valueList` - the list to be filled with values, can have any size.

#### pairsSortedByValue

    public void pairsSortedByValue(DoubleArrayList keyList,
                          IntArrayList valueList)

Fills all keys and values sorted ascending by value into the specified lists. Fills into the lists, starting at index 0. After this call returns the specified lists both have a new size that equals `this.size()`. Primary sort criterium is "value", secondary sort criterium is "key". This means that if any two values are equal, the smaller key comes first.

Example:
`keys = (8,7,6), values = (1,2,2) --> keyList = (8,6,7), valueList = (1,2,2)`

Parameters:
  `keyList` - the list to be filled with keys, can have any size.
  `valueList` - the list to be filled with values, can have any size.

#### put

    public abstract boolean put(double key,
              int value)

Associates the given key with the given value. Replaces any old `(key,someOtherValue)` association, if existing.

Parameters:
  `key` - the key the value shall be associated with.
  `value` - the value to be associated.
Returns:
  `true` if the receiver did not already contain such a key; `false` if the receiver did already contain such a key - the new value has now replaced the formerly associated value.

#### removeKey

    public abstract boolean removeKey(double key)

Removes the given key with its associated element from the receiver, if present.

Parameters:
  `key` - the key to be removed from the receiver.
Returns:
  `true` if the receiver contained the specified key, `false` otherwise.

#### toString

    public java.lang.String toString()

Returns a string representation of the receiver, containing the String representation of each key-value pair, sorted ascending by key.

Overrides:
  `toString` in class `java.lang.Object`

#### toStringByValue

    public java.lang.String toStringByValue()

Returns a string representation of the receiver, containing the String representation of each key-value pair, sorted ascending by value.

#### values

    public IntArrayList values()

Returns a list filled with all values contained in the receiver. The returned list has a size that equals `this.size()`. Iteration order is guaranteed to be identical to the order used by method `forEachKey(DoubleProcedure)`.

This method can be used to iterate over the values of the receiver.

Returns:
  the values.

#### values

    public void values(IntArrayList list)

Fills all values contained in the receiver into the specified list. Fills the list, starting at index 0. After this call returns the specified list has a new size that equals `this.size()`. Iteration order is guaranteed to be identical to the order used by method `forEachKey(DoubleProcedure)`.

This method can be used to iterate over the values of the receiver.

Parameters:
  `list` - the list to be filled, can have any size.